diff -Naur vendor-41.0.5/bitflags-1.3.2/tests/compile-fail/impls/eq.stderr.beta vendor-41.0.7/bitflags-1.3.2/tests/compile-fail/impls/eq.stderr.beta
--- vendor-41.0.5/bitflags-1.3.2/tests/compile-fail/impls/eq.stderr.beta	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/bitflags-1.3.2/tests/compile-fail/impls/eq.stderr.beta	1969-12-31 19:00:00.000000000 -0500
@@ -0,0 +1,55 @@
+error[E0119]: conflicting implementations of trait `std::cmp::PartialEq` for type `Flags`
+ --> $DIR/eq.rs:3:1
+  |
+3 | / bitflags! {
+4 | |     #[derive(PartialEq, Eq)]
+  | |              --------- first implementation here
+5 | |     struct Flags: u32 {
+6 | |         const A = 0b00000001;
+7 | |     }
+8 | | }
+  | |_^ conflicting implementation for `Flags`
+  |
+  = note: this error originates in the derive macro `PartialEq` (in Nightly builds, run with -Z macro-backtrace for more info)
+
+error[E0119]: conflicting implementations of trait `std::cmp::Eq` for type `Flags`
+ --> $DIR/eq.rs:3:1
+  |
+3 | / bitflags! {
+4 | |     #[derive(PartialEq, Eq)]
+  | |                         -- first implementation here
+5 | |     struct Flags: u32 {
+6 | |         const A = 0b00000001;
+7 | |     }
+8 | | }
+  | |_^ conflicting implementation for `Flags`
+  |
+  = note: this error originates in the derive macro `Eq` (in Nightly builds, run with -Z macro-backtrace for more info)
+
+error[E0119]: conflicting implementations of trait `std::marker::StructuralPartialEq` for type `Flags`
+ --> $DIR/eq.rs:3:1
+  |
+3 | / bitflags! {
+4 | |     #[derive(PartialEq, Eq)]
+  | |              --------- first implementation here
+5 | |     struct Flags: u32 {
+6 | |         const A = 0b00000001;
+7 | |     }
+8 | | }
+  | |_^ conflicting implementation for `Flags`
+  |
+  = note: this error originates in the derive macro `PartialEq` (in Nightly builds, run with -Z macro-backtrace for more info)
+
+error[E0119]: conflicting implementations of trait `std::marker::StructuralEq` for type `Flags`
+ --> $DIR/eq.rs:3:1
+  |
+3 | / bitflags! {
+4 | |     #[derive(PartialEq, Eq)]
+  | |                         -- first implementation here
+5 | |     struct Flags: u32 {
+6 | |         const A = 0b00000001;
+7 | |     }
+8 | | }
+  | |_^ conflicting implementation for `Flags`
+  |
+  = note: this error originates in the derive macro `Eq` (in Nightly builds, run with -Z macro-backtrace for more info)
diff -Naur vendor-41.0.5/bitflags-1.3.2/tests/compile-fail/non_integer_base/all_defined.rs vendor-41.0.7/bitflags-1.3.2/tests/compile-fail/non_integer_base/all_defined.rs
--- vendor-41.0.5/bitflags-1.3.2/tests/compile-fail/non_integer_base/all_defined.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/bitflags-1.3.2/tests/compile-fail/non_integer_base/all_defined.rs	1969-12-31 19:00:00.000000000 -0500
@@ -0,0 +1,123 @@
+use std::{
+    fmt::{
+        self,
+        Debug,
+        Display,
+        LowerHex,
+        UpperHex,
+        Octal,
+        Binary,
+    },
+    ops::{
+        BitAnd,
+        BitOr,
+        BitXor,
+        BitAndAssign,
+        BitOrAssign,
+        BitXorAssign,
+        Not,
+    },
+};
+
+use bitflags::bitflags;
+
+// Ideally we'd actually want this to work, but currently need something like `num`'s `Zero`
+// With some design work it could be made possible
+#[derive(Clone, Copy, PartialEq, Eq, PartialOrd, Ord, Hash)]
+struct MyInt(u8);
+
+impl BitAnd for MyInt {
+    type Output = Self;
+
+    fn bitand(self, other: Self) -> Self {
+        MyInt(self.0 & other.0)
+    }
+}
+
+impl BitOr for MyInt {
+    type Output = Self;
+
+    fn bitor(self, other: Self) -> Self {
+        MyInt(self.0 | other.0)
+    }
+}
+
+impl BitXor for MyInt {
+    type Output = Self;
+
+    fn bitxor(self, other: Self) -> Self {
+        MyInt(self.0 ^ other.0)
+    }
+}
+
+impl BitAndAssign for MyInt {
+    fn bitand_assign(&mut self, other: Self) {
+        self.0 &= other.0
+    }
+}
+
+impl BitOrAssign for MyInt {
+    fn bitor_assign(&mut self, other: Self) {
+        self.0 |= other.0
+    }
+}
+
+impl BitXorAssign for MyInt {
+    fn bitxor_assign(&mut self, other: Self) {
+        self.0 ^= other.0
+    }
+}
+
+impl Debug for MyInt {
+    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
+        Debug::fmt(&self.0, f)
+    }
+}
+
+impl Display for MyInt {
+    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
+        Display::fmt(&self.0, f)
+    }
+}
+
+impl LowerHex for MyInt {
+    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
+        LowerHex::fmt(&self.0, f)
+    }
+}
+
+impl UpperHex for MyInt {
+    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
+        UpperHex::fmt(&self.0, f)
+    }
+}
+
+impl Octal for MyInt {
+    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
+        Octal::fmt(&self.0, f)
+    }
+}
+
+impl Binary for MyInt {
+    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
+        Binary::fmt(&self.0, f)
+    }
+}
+
+impl Not for MyInt {
+    type Output = MyInt;
+
+    fn not(self) -> Self {
+        MyInt(!self.0)
+    }
+}
+
+bitflags! {
+    struct Flags128: MyInt {
+        const A = MyInt(0b0000_0001u8);
+        const B = MyInt(0b0000_0010u8);
+        const C = MyInt(0b0000_0100u8);
+    }
+}
+
+fn main() {}
diff -Naur vendor-41.0.5/bitflags-1.3.2/tests/compile-fail/non_integer_base/all_defined.stderr.beta vendor-41.0.7/bitflags-1.3.2/tests/compile-fail/non_integer_base/all_defined.stderr.beta
--- vendor-41.0.5/bitflags-1.3.2/tests/compile-fail/non_integer_base/all_defined.stderr.beta	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/bitflags-1.3.2/tests/compile-fail/non_integer_base/all_defined.stderr.beta	1969-12-31 19:00:00.000000000 -0500
@@ -0,0 +1,27 @@
+error[E0308]: mismatched types
+   --> $DIR/all_defined.rs:115:1
+    |
+115 | / bitflags! {
+116 | |     struct Flags128: MyInt {
+117 | |         const A = MyInt(0b0000_0001u8);
+118 | |         const B = MyInt(0b0000_0010u8);
+119 | |         const C = MyInt(0b0000_0100u8);
+120 | |     }
+121 | | }
+    | |_^ expected struct `MyInt`, found integer
+    |
+    = note: this error originates in the macro `__impl_all_bitflags` (in Nightly builds, run with -Z macro-backtrace for more info)
+
+error[E0308]: mismatched types
+   --> $DIR/all_defined.rs:115:1
+    |
+115 | / bitflags! {
+116 | |     struct Flags128: MyInt {
+117 | |         const A = MyInt(0b0000_0001u8);
+118 | |         const B = MyInt(0b0000_0010u8);
+119 | |         const C = MyInt(0b0000_0100u8);
+120 | |     }
+121 | | }
+    | |_^ expected struct `MyInt`, found integer
+    |
+    = note: this error originates in the macro `__impl_bitflags` (in Nightly builds, run with -Z macro-backtrace for more info)
diff -Naur vendor-41.0.5/bitflags-1.3.2/tests/compile-fail/non_integer_base/all_missing.rs vendor-41.0.7/bitflags-1.3.2/tests/compile-fail/non_integer_base/all_missing.rs
--- vendor-41.0.5/bitflags-1.3.2/tests/compile-fail/non_integer_base/all_missing.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/bitflags-1.3.2/tests/compile-fail/non_integer_base/all_missing.rs	1969-12-31 19:00:00.000000000 -0500
@@ -0,0 +1,13 @@
+use bitflags::bitflags;
+
+struct MyInt(u8);
+
+bitflags! {
+    struct Flags128: MyInt {
+        const A = MyInt(0b0000_0001);
+        const B = MyInt(0b0000_0010);
+        const C = MyInt(0b0000_0100);
+    }
+}
+
+fn main() {}
diff -Naur vendor-41.0.5/bitflags-1.3.2/tests/compile-fail/non_integer_base/all_missing.stderr.beta vendor-41.0.7/bitflags-1.3.2/tests/compile-fail/non_integer_base/all_missing.stderr.beta
--- vendor-41.0.5/bitflags-1.3.2/tests/compile-fail/non_integer_base/all_missing.stderr.beta	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/bitflags-1.3.2/tests/compile-fail/non_integer_base/all_missing.stderr.beta	1969-12-31 19:00:00.000000000 -0500
@@ -0,0 +1,13 @@
+error[E0204]: the trait `Copy` may not be implemented for this type
+  --> $DIR/all_missing.rs:5:1
+   |
+5  | / bitflags! {
+6  | |     struct Flags128: MyInt {
+7  | |         const A = MyInt(0b0000_0001);
+8  | |         const B = MyInt(0b0000_0010);
+9  | |         const C = MyInt(0b0000_0100);
+10 | |     }
+11 | | }
+   | |_^ this field does not implement `Copy`
+   |
+   = note: this error originates in the derive macro `Copy` (in Nightly builds, run with -Z macro-backtrace for more info)
diff -Naur vendor-41.0.5/bitflags-1.3.2/tests/compile-fail/visibility/private_field.rs vendor-41.0.7/bitflags-1.3.2/tests/compile-fail/visibility/private_field.rs
--- vendor-41.0.5/bitflags-1.3.2/tests/compile-fail/visibility/private_field.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/bitflags-1.3.2/tests/compile-fail/visibility/private_field.rs	1969-12-31 19:00:00.000000000 -0500
@@ -0,0 +1,13 @@
+mod example {
+    use bitflags::bitflags;
+
+    bitflags! {
+        pub struct Flags1: u32 {
+            const FLAG_A = 0b00000001;
+        }
+    }
+}
+
+fn main() {
+    let flag1 = example::Flags1::FLAG_A.bits;
+}
diff -Naur vendor-41.0.5/bitflags-1.3.2/tests/compile-fail/visibility/private_field.stderr.beta vendor-41.0.7/bitflags-1.3.2/tests/compile-fail/visibility/private_field.stderr.beta
--- vendor-41.0.5/bitflags-1.3.2/tests/compile-fail/visibility/private_field.stderr.beta	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/bitflags-1.3.2/tests/compile-fail/visibility/private_field.stderr.beta	1969-12-31 19:00:00.000000000 -0500
@@ -0,0 +1,10 @@
+error[E0616]: field `bits` of struct `Flags1` is private
+  --> $DIR/private_field.rs:12:41
+   |
+12 |     let flag1 = example::Flags1::FLAG_A.bits;
+   |                                         ^^^^ private field
+   |
+help: a method `bits` also exists, call it with parentheses
+   |
+12 |     let flag1 = example::Flags1::FLAG_A.bits();
+   |                                             ^^
diff -Naur vendor-41.0.5/bitflags-1.3.2/tests/compile-fail/visibility/private_flags.rs vendor-41.0.7/bitflags-1.3.2/tests/compile-fail/visibility/private_flags.rs
--- vendor-41.0.5/bitflags-1.3.2/tests/compile-fail/visibility/private_flags.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/bitflags-1.3.2/tests/compile-fail/visibility/private_flags.rs	1969-12-31 19:00:00.000000000 -0500
@@ -0,0 +1,18 @@
+mod example {
+    use bitflags::bitflags;
+
+    bitflags! {
+        pub struct Flags1: u32 {
+            const FLAG_A = 0b00000001;
+        }
+
+        struct Flags2: u32 {
+            const FLAG_B = 0b00000010;
+        }
+    }
+}
+
+fn main() {
+    let flag1 = example::Flags1::FLAG_A;
+    let flag2 = example::Flags2::FLAG_B;
+}
diff -Naur vendor-41.0.5/bitflags-1.3.2/tests/compile-fail/visibility/private_flags.stderr.beta vendor-41.0.7/bitflags-1.3.2/tests/compile-fail/visibility/private_flags.stderr.beta
--- vendor-41.0.5/bitflags-1.3.2/tests/compile-fail/visibility/private_flags.stderr.beta	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/bitflags-1.3.2/tests/compile-fail/visibility/private_flags.stderr.beta	1969-12-31 19:00:00.000000000 -0500
@@ -0,0 +1,18 @@
+error[E0603]: struct `Flags2` is private
+  --> $DIR/private_flags.rs:17:26
+   |
+17 |     let flag2 = example::Flags2::FLAG_B;
+   |                          ^^^^^^ private struct
+   |
+note: the struct `Flags2` is defined here
+  --> $DIR/private_flags.rs:4:5
+   |
+4  | /     bitflags! {
+5  | |         pub struct Flags1: u32 {
+6  | |             const FLAG_A = 0b00000001;
+7  | |         }
+...  |
+11 | |         }
+12 | |     }
+   | |_____^
+   = note: this error originates in the macro `bitflags` (in Nightly builds, run with -Z macro-backtrace for more info)
diff -Naur vendor-41.0.5/bitflags-1.3.2/tests/compile-fail/visibility/pub_const.rs vendor-41.0.7/bitflags-1.3.2/tests/compile-fail/visibility/pub_const.rs
--- vendor-41.0.5/bitflags-1.3.2/tests/compile-fail/visibility/pub_const.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/bitflags-1.3.2/tests/compile-fail/visibility/pub_const.rs	1969-12-31 19:00:00.000000000 -0500
@@ -0,0 +1,9 @@
+use bitflags::bitflags;
+
+bitflags! {
+    pub struct Flags1: u32 {
+        pub const FLAG_A = 0b00000001;
+    }
+}
+
+fn main() {}
diff -Naur vendor-41.0.5/bitflags-1.3.2/tests/compile-fail/visibility/pub_const.stderr.beta vendor-41.0.7/bitflags-1.3.2/tests/compile-fail/visibility/pub_const.stderr.beta
--- vendor-41.0.5/bitflags-1.3.2/tests/compile-fail/visibility/pub_const.stderr.beta	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/bitflags-1.3.2/tests/compile-fail/visibility/pub_const.stderr.beta	1969-12-31 19:00:00.000000000 -0500
@@ -0,0 +1,5 @@
+error: no rules expected the token `pub`
+ --> $DIR/pub_const.rs:5:9
+  |
+5 |         pub const FLAG_A = 0b00000001;
+  |         ^^^ no rules expected this token in macro call
diff -Naur vendor-41.0.5/bitflags-1.3.2/tests/compile-pass/impls/convert.rs vendor-41.0.7/bitflags-1.3.2/tests/compile-pass/impls/convert.rs
--- vendor-41.0.5/bitflags-1.3.2/tests/compile-pass/impls/convert.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/bitflags-1.3.2/tests/compile-pass/impls/convert.rs	1969-12-31 19:00:00.000000000 -0500
@@ -0,0 +1,17 @@
+use bitflags::bitflags;
+
+bitflags! {
+    struct Flags: u32 {
+        const A = 0b00000001;
+    }
+}
+
+impl From<u32> for Flags {
+    fn from(v: u32) -> Flags {
+        Flags::from_bits_truncate(v)
+    }
+}
+
+fn main() {
+
+}
diff -Naur vendor-41.0.5/bitflags-1.3.2/tests/compile-pass/impls/default.rs vendor-41.0.7/bitflags-1.3.2/tests/compile-pass/impls/default.rs
--- vendor-41.0.5/bitflags-1.3.2/tests/compile-pass/impls/default.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/bitflags-1.3.2/tests/compile-pass/impls/default.rs	1969-12-31 19:00:00.000000000 -0500
@@ -0,0 +1,10 @@
+use bitflags::bitflags;
+
+bitflags! {
+    #[derive(Default)]
+    struct Flags: u32 {
+        const A = 0b00000001;
+    }
+}
+
+fn main() {}
diff -Naur vendor-41.0.5/bitflags-1.3.2/tests/compile-pass/impls/inherent_methods.rs vendor-41.0.7/bitflags-1.3.2/tests/compile-pass/impls/inherent_methods.rs
--- vendor-41.0.5/bitflags-1.3.2/tests/compile-pass/impls/inherent_methods.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/bitflags-1.3.2/tests/compile-pass/impls/inherent_methods.rs	1969-12-31 19:00:00.000000000 -0500
@@ -0,0 +1,15 @@
+use bitflags::bitflags;
+
+bitflags! {
+    struct Flags: u32 {
+        const A = 0b00000001;
+    }
+}
+
+impl Flags {
+    pub fn new() -> Flags {
+        Flags::A
+    }
+}
+
+fn main() {}
diff -Naur vendor-41.0.5/bitflags-1.3.2/tests/compile-pass/redefinition/core.rs vendor-41.0.7/bitflags-1.3.2/tests/compile-pass/redefinition/core.rs
--- vendor-41.0.5/bitflags-1.3.2/tests/compile-pass/redefinition/core.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/bitflags-1.3.2/tests/compile-pass/redefinition/core.rs	1969-12-31 19:00:00.000000000 -0500
@@ -0,0 +1,14 @@
+use bitflags::bitflags;
+
+// Checks for possible errors caused by overriding names used by `bitflags!` internally.
+
+mod core {}
+mod _core {}
+
+bitflags! {
+    struct Test: u8 {
+        const A = 1;
+    }
+}
+
+fn main() {}
diff -Naur vendor-41.0.5/bitflags-1.3.2/tests/compile-pass/redefinition/stringify.rs vendor-41.0.7/bitflags-1.3.2/tests/compile-pass/redefinition/stringify.rs
--- vendor-41.0.5/bitflags-1.3.2/tests/compile-pass/redefinition/stringify.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/bitflags-1.3.2/tests/compile-pass/redefinition/stringify.rs	1969-12-31 19:00:00.000000000 -0500
@@ -0,0 +1,19 @@
+use bitflags::bitflags;
+
+// Checks for possible errors caused by overriding names used by `bitflags!` internally.
+
+#[allow(unused_macros)]
+macro_rules! stringify {
+    ($($t:tt)*) => { "..." };
+}
+
+bitflags! {
+    struct Test: u8 {
+        const A = 1;
+    }
+}
+
+fn main() {
+    // Just make sure we don't call the redefined `stringify` macro
+    assert_eq!(format!("{:?}", Test::A), "A");
+}
diff -Naur vendor-41.0.5/bitflags-1.3.2/tests/compile-pass/repr/c.rs vendor-41.0.7/bitflags-1.3.2/tests/compile-pass/repr/c.rs
--- vendor-41.0.5/bitflags-1.3.2/tests/compile-pass/repr/c.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/bitflags-1.3.2/tests/compile-pass/repr/c.rs	1969-12-31 19:00:00.000000000 -0500
@@ -0,0 +1,10 @@
+use bitflags::bitflags;
+
+bitflags! {
+    #[repr(C)]
+    struct Flags: u32 {
+        const A = 0b00000001;
+    }
+}
+
+fn main() {}
diff -Naur vendor-41.0.5/bitflags-1.3.2/tests/compile-pass/repr/transparent.rs vendor-41.0.7/bitflags-1.3.2/tests/compile-pass/repr/transparent.rs
--- vendor-41.0.5/bitflags-1.3.2/tests/compile-pass/repr/transparent.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/bitflags-1.3.2/tests/compile-pass/repr/transparent.rs	1969-12-31 19:00:00.000000000 -0500
@@ -0,0 +1,10 @@
+use bitflags::bitflags;
+
+bitflags! {
+    #[repr(transparent)]
+    struct Flags: u32 {
+        const A = 0b00000001;
+    }
+}
+
+fn main() {}
diff -Naur vendor-41.0.5/bitflags-1.3.2/tests/compile-pass/visibility/bits_field.rs vendor-41.0.7/bitflags-1.3.2/tests/compile-pass/visibility/bits_field.rs
--- vendor-41.0.5/bitflags-1.3.2/tests/compile-pass/visibility/bits_field.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/bitflags-1.3.2/tests/compile-pass/visibility/bits_field.rs	1969-12-31 19:00:00.000000000 -0500
@@ -0,0 +1,11 @@
+use bitflags::bitflags;
+
+bitflags! {
+    pub struct Flags1: u32 {
+        const FLAG_A = 0b00000001;
+    }
+}
+
+fn main() {
+    assert_eq!(0b00000001, Flags1::FLAG_A.bits);
+}
diff -Naur vendor-41.0.5/bitflags-1.3.2/tests/compile-pass/visibility/pub_in.rs vendor-41.0.7/bitflags-1.3.2/tests/compile-pass/visibility/pub_in.rs
--- vendor-41.0.5/bitflags-1.3.2/tests/compile-pass/visibility/pub_in.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/bitflags-1.3.2/tests/compile-pass/visibility/pub_in.rs	1969-12-31 19:00:00.000000000 -0500
@@ -0,0 +1,19 @@
+mod a {
+    mod b {
+        use bitflags::bitflags;
+
+        bitflags! {
+            pub(in crate::a) struct Flags: u32 {
+                const FLAG_A = 0b00000001;
+            }
+        }
+    }
+
+    pub fn flags() -> u32 {
+        b::Flags::FLAG_A.bits()
+    }
+}
+
+fn main() {
+    assert_eq!(0b00000001, a::flags());
+}
diff -Naur vendor-41.0.5/bitflags-1.3.2/tests/compile.rs vendor-41.0.7/bitflags-1.3.2/tests/compile.rs
--- vendor-41.0.5/bitflags-1.3.2/tests/compile.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/bitflags-1.3.2/tests/compile.rs	1969-12-31 19:00:00.000000000 -0500
@@ -0,0 +1,63 @@
+use std::{
+    fs,
+    ffi::OsStr,
+    io,
+    path::Path,
+};
+
+use walkdir::WalkDir;
+
+#[test]
+fn fail() {
+    prepare_stderr_files("tests/compile-fail").unwrap();
+
+    let t = trybuild::TestCases::new();
+    t.compile_fail("tests/compile-fail/**/*.rs");
+}
+
+#[test]
+fn pass() {
+    let t = trybuild::TestCases::new();
+    t.pass("tests/compile-pass/**/*.rs");
+}
+
+// Compiler messages may change between versions
+// We don't want to have to track these too closely for `bitflags`, but
+// having some message to check makes sure user-facing errors are sensical.
+// 
+// The approach we use is to run the test on all compilers, but only check stderr
+// output on beta (which is the next stable release). We do this by default ignoring
+// any `.stderr` files in the `compile-fail` directory, and copying `.stderr.beta` files
+// when we happen to be running on a beta compiler.
+fn prepare_stderr_files(path: impl AsRef<Path>) -> io::Result<()> {
+    for entry in WalkDir::new(path) {
+        let entry = entry?;
+
+        if entry.path().extension().and_then(OsStr::to_str) == Some("beta") {
+            let renamed = entry.path().with_extension("");
+
+            // Unconditionally remove a corresponding `.stderr` file for a `.stderr.beta`
+            // file if it exists. On `beta` compilers, we'll recreate it. On other compilers,
+            // we don't want to end up checking it anyways.
+            if renamed.exists() {
+                fs::remove_file(&renamed)?;
+            }
+
+            rename_beta_stderr(entry.path(), renamed)?;
+        }
+    }
+
+    Ok(())
+}
+
+#[rustversion::beta]
+fn rename_beta_stderr(from: impl AsRef<Path>, to: impl AsRef<Path>) -> io::Result<()> {
+    fs::copy(from, to)?;
+
+    Ok(())
+}
+
+#[rustversion::not(beta)]
+fn rename_beta_stderr(_: impl AsRef<Path>, _: impl AsRef<Path>) -> io::Result<()> {
+    Ok(())
+}
diff -Naur vendor-41.0.5/openssl/build.rs vendor-41.0.7/openssl/build.rs
--- vendor-41.0.5/openssl/build.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/openssl/build.rs	1969-12-31 19:00:00.000000000 -0500
@@ -13,7 +13,6 @@
 
     if env::var("DEP_OPENSSL_BORINGSSL").is_ok() {
         println!("cargo:rustc-cfg=boringssl");
-        return;
     }
 
     if let Ok(v) = env::var("DEP_OPENSSL_LIBRESSL_VERSION_NUMBER") {
@@ -67,6 +66,12 @@
         if version >= 0x3_07_00_00_0 {
             println!("cargo:rustc-cfg=libressl370");
         }
+        if version >= 0x3_08_00_00_0 {
+            println!("cargo:rustc-cfg=libressl380");
+        }
+        if version >= 0x3_08_02_00_0 {
+            println!("cargo:rustc-cfg=libressl382");
+        }
     }
 
     if let Ok(vars) = env::var("DEP_OPENSSL_CONF") {
@@ -102,61 +107,8 @@
         if version >= 0x3_01_00_00_0 {
             println!("cargo:rustc-cfg=ossl310");
         }
-    }
-
-    if let Ok(version) = env::var("DEP_OPENSSL_LIBRESSL_VERSION_NUMBER") {
-        let version = u64::from_str_radix(&version, 16).unwrap();
-
-        if version >= 0x2_05_01_00_0 {
-            println!("cargo:rustc-cfg=libressl251");
-        }
-
-        if version >= 0x2_06_01_00_0 {
-            println!("cargo:rustc-cfg=libressl261");
-        }
-
-        if version >= 0x2_07_00_00_0 {
-            println!("cargo:rustc-cfg=libressl270");
-        }
-
-        if version >= 0x2_07_01_00_0 {
-            println!("cargo:rustc-cfg=libressl271");
-        }
-
-        if version >= 0x2_07_03_00_0 {
-            println!("cargo:rustc-cfg=libressl273");
-        }
-
-        if version >= 0x2_08_00_00_0 {
-            println!("cargo:rustc-cfg=libressl280");
-        }
-
-        if version >= 0x2_09_01_00_0 {
-            println!("cargo:rustc-cfg=libressl291");
-        }
-
-        if version >= 0x3_02_01_00_0 {
-            println!("cargo:rustc-cfg=libressl321");
-        }
-
-        if version >= 0x3_03_02_00_0 {
-            println!("cargo:rustc-cfg=libressl332");
-        }
-
-        if version >= 0x3_04_00_00_0 {
-            println!("cargo:rustc-cfg=libressl340");
-        }
-
-        if version >= 0x3_05_00_00_0 {
-            println!("cargo:rustc-cfg=libressl350");
-        }
-
-        if version >= 0x3_06_00_00_0 {
-            println!("cargo:rustc-cfg=libressl360");
-        }
-
-        if version >= 0x3_06_01_00_0 {
-            println!("cargo:rustc-cfg=libressl361");
+        if version >= 0x3_02_00_00_0 {
+            println!("cargo:rustc-cfg=ossl320");
         }
     }
 }
diff -Naur vendor-41.0.5/openssl/Cargo.toml vendor-41.0.7/openssl/Cargo.toml
--- vendor-41.0.5/openssl/Cargo.toml	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/openssl/Cargo.toml	1969-12-31 19:00:00.000000000 -0500
@@ -12,7 +12,7 @@
 [package]
 edition = "2018"
 name = "openssl"
-version = "0.10.54"
+version = "0.10.60"
 authors = ["Steven Fackler <sfackler@gmail.com>"]
 description = "OpenSSL bindings"
 readme = "README.md"
@@ -30,13 +30,13 @@
 repository = "https://github.com/sfackler/rust-openssl"
 
 [dependencies.bitflags]
-version = "1.0"
+version = "2.2.1"
 
 [dependencies.cfg-if]
 version = "1.0"
 
 [dependencies.ffi]
-version = "0.9.88"
+version = "0.9.96"
 package = "openssl-sys"
 
 [dependencies.foreign-types]
diff -Naur vendor-41.0.5/openssl/src/asn1.rs vendor-41.0.7/openssl/src/asn1.rs
--- vendor-41.0.5/openssl/src/asn1.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/openssl/src/asn1.rs	1969-12-31 19:00:00.000000000 -0500
@@ -738,7 +738,7 @@
 }
 
 cfg_if! {
-    if #[cfg(any(ossl110, libressl273))] {
+    if #[cfg(any(ossl110, libressl273, boringssl))] {
         use ffi::ASN1_STRING_get0_data;
     } else {
         #[allow(bad_style)]
diff -Naur vendor-41.0.5/openssl/src/bn.rs vendor-41.0.7/openssl/src/bn.rs
--- vendor-41.0.5/openssl/src/bn.rs	1969-12-31 19:00:00.000000000 -0500
+++ vendor-41.0.7/openssl/src/bn.rs	1969-12-31 19:00:00.000000000 -0500
@@ -335,6 +335,20 @@
         unsafe { BN_is_negative(self.as_ptr()) == 1 }
     }
 
+    /// Returns `true` is `self` is even.
+    #[corresponds(BN_is_even)]
+    #[cfg(any(ossl110, boringssl, libressl350))]
+    pub fn is_even(&self) -> bool {
+        !self.is_odd()
+    }
+
+    /// Returns `true` is `self` is odd.
+    #[corresponds(BN_is_odd)]
+    #[cfg(any(ossl110, boringssl, libressl350))]
+    pub fn is_odd(&self) -> bool {
+        unsafe { ffi::BN_is_odd(self.as_ptr()) == 1 }
+    }
+
     /// Returns the number of significant bits in `self`.
     #[corresponds(BN_num_bits)]
     #[allow(clippy::unnecessary_cast)]
@@ -639,6 +653,25 @@
         }
     }
 
+    /// Places into `self` the modular square root of `a` such that `self^2 = a (mod p)`
+    #[corresponds(BN_mod_sqrt)]
+    pub fn mod_sqrt(
+        &mut self,
+        a: &BigNumRef,
+        p: &BigNumRef,
+        ctx: &mut BigNumContextRef,
+    ) -> Result<(), ErrorStack> {
+        unsafe {
+            cvt_p(ffi::BN_mod_sqrt(
+                self.as_ptr(),
+                a.as_ptr(),
+                p.as_ptr(),
+                ctx.as_ptr(),
+            ))
+            .map(|_| ())
+        }
+    }
+
     /// Places the result of `a^p` in `self`.
     #[corresponds(BN_exp)]
     pub fn exp(
@@ -1195,7 +1228,7 @@
 
 impl PartialOrd for BigNum {
     fn partial_cmp(&self, oth: &BigNum) -> Option<Ordering> {
-        self.deref().partial_cmp(oth.deref())
+        Some(self.cmp(oth))
     }
 }
 
@@ -1455,4 +1488,36 @@
         b.set_const_time();
         assert!(b.is_const_time())
     }
+
+    #[test]
+    fn test_mod_sqrt() {
+        let mut ctx = BigNumContext::new().unwrap();
+
+        let s = BigNum::from_hex_str("2").unwrap();
+        let p = BigNum::from_hex_str("7DEB1").unwrap();
+        let mut sqrt = BigNum::new().unwrap();
+        let mut out = BigNum::new().unwrap();
+
+        // Square the root because OpenSSL randomly returns one of 2E42C or 4FA85
+        sqrt.mod_sqrt(&s, &p, &mut ctx).unwrap();
+        out.mod_sqr(&sqrt, &p, &mut ctx).unwrap();
+        assert!(out == s);
+
+        let s = BigNum::from_hex_str("3").unwrap();
+        let p = BigNum::from_hex_str("5").unwrap();
+        assert!(out.mod_sqrt(&s, &p, &mut ctx).is_err());
+    }
+
+    #[test]
+    #[cfg(any(ossl110, boringssl, libressl350))]
+    fn test_odd_even() {
+        let a = BigNum::from_u32(17).unwrap();
+        let b = BigNum::from_u32(18).unwrap();
+
+        assert!(a.is_odd());
+        assert!(!b.is_odd());
+
+        assert!(!a.is_even());
+        assert!(b.is_even());
+    }
 }
